//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "Unit1.h"
#include "intelhex.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

//25C020f[^
#define DATA_SIZE	256
#define PAGE_SIZE	4

unsigned char DatBuff[DATA_SIZE];

//SPI EEPROM Command
#define ON	1
#define OFF	0
#define CM_READ		0x03	//Read
#define CM_WRITE	0x02	//Write
#define CM_WRDI		0x04	//Write Disable
#define	CM_WREN		0x06	//Write Enable
#define CM_RDSR		0x05	//Read Status
#define CM_WRSR		0x01	//Write Status

int PortNo=3;		//|[g̔ԍiP`j
HANDLE hCom=INVALID_HANDLE_VALUE;	//|[g̃nh

//---------------------------------------------------------------------------
//SPIC^[tF[X֐
//---------------------------------------------------------------------------
bool SpiOpen(int port)
{
	char comname[20];

	if((port<0)||(hCom!=INVALID_HANDLE_VALUE))	//|[gԍAłɃI[v̏ꍇ
		return false;
	sprintf(comname,"\\\\.\\COM%d",port+1);
	hCom=CreateFile(comname,GENERIC_READ | GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);

	if(hCom==INVALID_HANDLE_VALUE){
		return false;
	}
	return true;
}

//---------------------------------------------------------------------------
void SpiClose()
{
	if(hCom)
		CloseHandle(hCom);
	hCom=INVALID_HANDLE_VALUE;
}

//---------------------------------------------------------------------------
void SpiCS(bool ctl)
{
	//ctr=true̎ACSANeBuiCS=L)
	if(ctl)
		EscapeCommFunction(hCom,SETDTR);
	else
		EscapeCommFunction(hCom,CLRDTR);

}
//---------------------------------------------------------------------------
void SpiWE(bool enable)
{
	//SPIfoCX̏݋
    char cmd;
    DWORD	wsize;
    if(enable)
    	cmd=CM_WREN;
    else
    	cmd=CM_WRDI;
    SpiCS(true);
	WriteFile(hCom,(void *)&cmd,1,&wsize,NULL);
    ReadFile(hCom,(void *)&cmd,1,&wsize,NULL);
    SpiCS(false);

}
//---------------------------------------------------------------------------
char SpiStatus()
{
    DWORD	wsize;
	char buf[2];
    buf[0]=CM_RDSR;
    SpiCS(true);
	WriteFile(hCom,(void *)&buf,2,&wsize,NULL);
    ReadFile(hCom,(void *)&buf,2,&wsize,NULL);
    SpiCS(false);
	return buf[1];
}
//---------------------------------------------------------------------------
void SpiRead(int adr,char *buff,int size)
{
	//SPIfoCXAf[^ǂݏo
    DWORD	wsize;
    char wbuf[64];

    size+=2;
    if(size>64)
    	size=64;
    SpiCS(true);
    wbuf[0]=CM_READ;
    wbuf[1]=(char)adr;
	WriteFile(hCom,(void *)wbuf,size,&wsize,NULL);
    ReadFile(hCom,(void *)wbuf,size,&wsize,NULL);
    SpiCS(false);
    size-=2;
    memcpy(buff,&wbuf[2],size);
}
//---------------------------------------------------------------------------
void SpiWrite(int adr,char *buff,int size)
{
	//SPIfoCXAf[^ǂݏo
    DWORD	wsize;
    char wbuf[64];

    if(size>62)
    	size=62;

    SpiWE(true);
    SpiCS(true);
    wbuf[0]=CM_WRITE;
    wbuf[1]=(char)adr;
    memcpy(&wbuf[2],buff,size);
    size+=2;
	WriteFile(hCom,(void *)wbuf,size,&wsize,NULL);
    ReadFile(hCom,(void *)wbuf,size,&wsize,NULL);
    SpiCS(false);
    //݊҂
    while(SpiStatus() & CM_WRSR ){
    	Sleep(10);
    }
}
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormActivate(TObject *Sender)
{
	cbPort->ItemIndex=2;
	BuffClear();
    ShowData();

}
//---------------------------------------------------------------------------
void TForm1::ShowData()
{
	//f[^_v
    int adr,i;
    AnsiString str,wstr;
	Memo1->Lines->Clear();
	adr=0;
    while(adr<DATA_SIZE){
    	str.printf("%04X: ",adr);
        for(i=0;i<16;i++){
        	wstr.printf("%02X ",DatBuff[adr+i]);
            str+=wstr;
        }
        Memo1->Lines->Add(str);
        adr+=16;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mnOpenClick(TObject *Sender)
{
	bool retc;
	FILE *fp;
	if(!OpenDialog1->Execute())
    	return;
	BuffClear();
   	//CeHEXt@C̓ǂݍ
    if(!LoadIHex(OpenDialog1->FileName.c_str(),DatBuff,DATA_SIZE)){
    		ShowMessage("t@C̓ǂݍ݂Ɏs܂B");
    }else{
    	ShowData();
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mnSaveClick(TObject *Sender)
{
	bool retc;
	FILE *fp;
	if(!SaveDialog1->Execute())
    	return;

   	//CeHEXt@C̏o
    if(!SaveIHex(SaveDialog1->FileName.c_str(),DatBuff,DATA_SIZE)){
    		ShowMessage("t@C݂̏Ɏs܂B");
    }

}
//---------------------------------------------------------------------------
void __fastcall TForm1::mnReadClick(TObject *Sender)
{
    int adr;

    if(!SpiOpen(cbPort->ItemIndex)){
    	ShowMessage("|[g̃I[vɎs܂B");
        return;
    }
    adr=0;
    while(adr<DATA_SIZE){
    	SpiRead(adr,&DatBuff[adr],16);
        adr+=16;
    }
    SpiClose();
    ShowData();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mnWriteClick(TObject *Sender)
{
    int adr;

    if(!SpiOpen(cbPort->ItemIndex)){
    	ShowMessage("|[g̃I[vɎs܂B");
        return;
    }
    adr=0;
    ProgressBar1->Position=0;
	ProgressBar1->Max=DATA_SIZE;
    while(adr<DATA_SIZE){
    	SpiWrite(adr,&DatBuff[adr],PAGE_SIZE);
        adr+=PAGE_SIZE;
        ProgressBar1->Position=adr;
        Application->ProcessMessages();
    }
    SpiClose();
    ProgressBar1->Position=0;


}
//---------------------------------------------------------------------------
void __fastcall TForm1::mnCompareClick(TObject *Sender)
{
    int adr;
	char buff[16];
    if(!SpiOpen(cbPort->ItemIndex)){
    	ShowMessage("|[g̃I[vɎs܂B");
        return;
    }
    adr=0;
    while(adr<DATA_SIZE){
    	SpiRead(adr,buff,16);
        if(memcmp(buff,&DatBuff[adr],16)){
        	break;
        }
        adr+=16;
    }
    SpiClose();
    if(adr<DATA_SIZE)
    	ShowMessage("f[^͈v܂łB");
    else
    	ShowMessage("f[^͈v܂B");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::mnExitClick(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------
void TForm1::BuffClear()
{
    memset(DatBuff,0xff,DATA_SIZE);
}


void __fastcall TForm1::mnBufClearClick(TObject *Sender)
{
	BuffClear();
    ShowData();

}
//---------------------------------------------------------------------------

