#include <stdio.h>

#include "intelhex.h"

//===========================================================================
//	Intel Hex Tools
//===========================================================================
struct IHexHeader{
	char	RECMark;
    char	RECLen[2];
    char	LoadAdr[4];
    char	RECType[2];
    char	Data[];
};
//=============================================================================
int HexToInt(char *buf,int len)
{
	char bch;
    int dat;

    if(len!=0){
    	bch=buf[len];
        buf[len]=0;
	    sscanf(buf,"%x",&dat);
        buf[len]=bch;
    }else{
	    sscanf(buf,"%x",&dat);
    }
	return dat;
}

//---------------------------------------------------------------------------
int LoadIHex(char *fname, unsigned char * dbuf, int size)
{
    const int bufsz=256;
    char buff[bufsz];		// 1C̍ő吔
	int	i,adr,type,ladr,dat,len,seg,csum,eseg;
    int csumerr,areaerr;
    IHexHeader *IHH;
	FILE *fp;
    areaerr=0;
    IHH=(IHexHeader *)buff;
	fp=fopen(fname,"rt");
    if(fp==NULL)
    	return 0;


    seg=0;
    eseg=0;			//gZOg
    csumerr=0;
    //C[v
    while(fgets(buff,bufsz,fp)){
		//check header mark
        if(IHH->RECMark!=':')
        	continue;
        // Check Sum Check
        len=HexToInt(IHH->RECLen,2);
		csum=0;
        for(i=0;i<(len+5);i++){
        	csum+=HexToInt(&buff[i*2+1],2);
        }
        csum&=0xff;
        if(csum){
        	csumerr=1;
        }
		type=HexToInt(IHH->RECType,2);
        switch(type){
        case 0:
        	//f[^R[h
            len=HexToInt(IHH->RECLen,2);
            adr=HexToInt(IHH->LoadAdr,4);
            for(i=0;i<len;i++){
            	dat=HexToInt((char *)(IHH->Data + i*2),2);
				ladr=(seg << 4) + adr;
                if(ladr<size)
	                dbuf[ladr]=(unsigned char)dat;
                adr++;
            }
        	break;

        case 2:
        	//ZOgR[h
            seg=HexToInt(IHH->Data,4);
        	break;

        case 4:
        	//gZOgR[h
            eseg=HexToInt(IHH->Data,4);
            eseg<<=16;
        	break;

        case 1:
        	//IR[h
		    fclose(fp);
            if(csumerr){
                return 0;
            }
		    if(areaerr){
		        return 0;
    		}
    		return 1;
        }
    }
    fclose(fp);
    //IR[hĂȂ
    if(csumerr){
        return 0;
    }
    if(areaerr){
        return 0;
    }
    return 1;
}
//---------------------------------------------------------------------------
int SaveIHex(char *fname, unsigned char *buf, int size)
{
	int	i,j,adr,ladr,seg,oseg,csum,datc,eseg;
    int saveflg;
    int MChipMode;
	char str[256];
    FILE *fp;


	fp=fopen(fname,"wt");
    if(!fp)
    	return 0;

    ladr=0;
    oseg=seg=0;
	eseg=0;

#if 0
     //gZOgf[^𖄂ߍ
	   fprintf(fp,":020000040000FA\n");
#endif
    while(ladr<size){
    	datc=16;

		if((size-ladr)<datc){
        	datc=size-ladr;
        }
        adr=ladr;
        csum=-(adr & 0xff) - (adr >> 8) -datc;

        //f[^`FbNA0xff̃f[^͕ۑȂ
        for(i=0;i<datc;i++){
            if(buf[ladr+i]!=0xff)
               	break;
        }
        if(i!=datc)
			saveflg=1;
        else
        	saveflg=0;
        //print header
        if(saveflg){
	        fprintf(fp,":%02X%04X00",datc,adr);
        }
        while(datc){
	        if(saveflg){
	        	fprintf(fp,"%02X",buf[ladr]);
            }
			csum-=buf[ladr];
            ladr++;
            datc--;
        }
        csum &=0xff;
        if(saveflg)
	        fprintf(fp,"%02X\n",csum);

        seg=(ladr & 0xf0000) >> 4;
        if((seg!=oseg)&&(ladr<size)){
        	//add segment
			csum=-4-(seg >> 8);
            csum &=0xff;
            fprintf(fp,":02000002%04X%02X\n",seg,csum);
            oseg=seg;
        }
    }

    //end record
    fprintf(fp,":00000001FF\n");

    fclose(fp);
    return 1;
}


