
#ifndef _CDC_H_
#define _CDC_H_
#include <system.h>

#define BULK_IN_EP	1
#define BULK_OUT_EP	2
#define BulkOut(b,s)	ReadEndpoint(BULK_OUT_EP,b,s)
#define BulkIn(b,s)		WriteEndpoint(BULK_IN_EP,b,s)
#define BIT_DTR	0
#define BIT_RTS	1

//===================================
//	CDC Class Request
//===================================
#define SET_LINE_CODING			0x20
#define GET_LINE_CODING			0x21
#define SET_CONTROL_LINE_STATE	0x22

//===================================
//	Structure
//===================================
struct BufferDescriptorEntry  // buffer descriptor 
{
	unsigned char EPStat;
	unsigned char bytes;
	unsigned int address;
};

struct RequestPacket	  // buffer structure 
{
	unsigned char bmRequestType;
	unsigned char bRequest;
	unsigned int   wValue;
	unsigned int   wIndex;
	unsigned int   wLength;
};

struct LineCodingStructure{
	unsigned long dwDTERate;
	unsigned char bCharFormat;
	unsigned char bParityType;
	unsigned char bDataBits;
};


//===================================
//	Externs
//===================================
extern unsigned char USB_dev_req;
extern unsigned char USB_Curr_Config; 
extern unsigned char USB_address_pending;
extern unsigned char USWSTAT;
extern volatile unsigned char CtrlLineBmp;	// bit 0=DTR,Bit 1=RTS
extern volatile unsigned char LineCoding[7];
//extern struct LineCodingStructure LineCoding;
//===================================
//	Public Prototypes
//===================================
extern void InitUSB ();
extern void USBReset ();
extern void USBActivity ();
extern void UsbInt ();
extern char ReadEndpoint(char endpoint,char *buff,char size);
extern char WriteEndpoint(char endpoint,char *buff,char size);

#endif	//_CDC_H_
