#include <system.h>
#include <ctype.h>
#include <string.h>
#include "spi.h"

//Definition for SPI
#define XCSPORT		porta
#define XCSBIT		3
#define DCSPORT		porta
#define DCSBIT		4

//for SPI Soft Emulation
#define SPI_CLK(x)	 (x) ? set_bit(portb,1) : clear_bit(portb,1)
#define SPI_MISO(x) (x) ? set_bit(portc,7) : clear_bit(portc,7)
#define SPI_MOSI() test_bit(portb,0)

//SPI EEPROM Command
#define ON	1
#define OFF	0
#define CM_READ		0x03	//Read
#define CM_WRITE	0x02	//Write
#define CM_WRDI		0x04	//Write Disable
#define	CM_WREN		0x06	//Write Enable
#define CM_RDSR		0x05	//Read Status
#define CM_WRSR		0x01	//Write Status

#define true 	1
#define false 	0
char EditMode=false;
int EditAdr  =0;
char EditDat =0;
char EditCnt =0;
char AdrLen  =8;		//Address Bit Length

//===============================================================================
//SPI Basic Functions
//===============================================================================
void SpiCS(unsigned char mode)
{
	if(mode)
		clear_bit(XCSPORT,XCSBIT);	//Activate CS
	else
		set_bit(XCSPORT,XCSBIT);	//inactivate CS
}
//---------------------------------------------------------------------------
void SpiInit()
{
	//SPȈ
	SpiCS(OFF);
#ifndef _SOFT_SPI_	
	sspstat=0x40;	//SMP=0,CKE=1,CKE=1
	sspcon1=0x22;	//22h=SPI CLK=625KHz
#else
	sspcon1=0;	//SPI Port->I/O Port
	SPI_CLK(0);
#endif
}
//---------------------------------------------------------------------------
unsigned char SpiRW(unsigned char dat)
{
	unsigned char rdat;
#ifndef _SOFT_SPI_	
	sspbuf=dat;	//Send Data
	while(!test_bit(sspstat,0));
	rdat=sspbuf;
#else
	char i;
	rdat=0;
	for(i=0;i<8;i++){
		rdat<<=1;
		SPI_MISO(dat & 0x80);
		SPI_CLK(1);
		SPI_CLK(0);
		rdat|=SPI_MOSI();
		dat <<=1;
	}
#endif
	return rdat;
}
