#ifndef _USB_DEFS_
#define _USB_DEFS_

#define TRUE   1
#define FALSE  0
#define NULL   0

//Packet Size
#define CTRL_PKTSZ	8	//Control Transfer
#define BULK_PKTSZ	64	//Bulk Transfer
#define INTR_PKTSZ	8	//Interrupt Transfer
// BDT Bits
#define BDT_BSTALL	0x04
#define BDT_DTSEN	0x08
#define BDT_INCDIS	0x10
#define BDT_KEN		0x20
#define BDT_DTS		0x40
#define BDT_UOWN	0x80


#define DEBUG_SERIAL 	1
#define NUM_CONFIGURATIONS      1
#define NUM_INTERFACES          1

#define ConfiguredUSB() ((USWSTAT&0x3) == CONFIG_STATE)
#define STALL_EP0    	set_bit(uep0,EPSTALL)
#if 0
#define STALL_PID_EP0IN 	bd0statie = 0xCC  /* REQUEST ERROR */
#define Send_0Len_pkt	bd0cntie = 0;	bd0statie = 0xc8;	USB_dev_req = NULL
#else
#define STALL_PID_EP0IN 	BDT[EP0IN].EPStat = BDT_UOWN | BDT_DTS | BDT_DTSEN | BDT_BSTALL  /* REQUEST ERROR */
#define Send_0Len_pkt	BDT[EP0IN].bytes=0;	BDT[EP0IN].EPStat= BDT_UOWN | BDT_DTS | BDT_DTSEN;	USB_dev_req = NULL
#endif

/* Device Class Code */
#define CDC_DEVICE              0x02
#define EP0_BUFF_SIZE           8
/* Communication Interface Class Code */
#define COMM_INTF                   0x02
/* Communication Interface Class SubClass Codes */
#define ABSTRACT_CONTROL_MODEL      0x02
/* Communication Interface Class Control Protocol Codes */
#define V25TER                      0x01    // Common AT commands ("Hayes(TM)")
/* Data Interface Class Codes */
#define DATA_INTF                   0x0A
/* Data Interface Class Protocol Codes */
#define NO_PROTOCOL                 0x00    // No class specific protocol required


#define POWERED_STATE	        0x00
#define DEFAULT_STATE	        0x01
#define ADDRESS_STATE	        0x02
#define CONFIG_STATE	        0x03
#define ENDPT_DISABLED	        0x10  // For 18F2455 with handshaking
#define ENDPT_IN_ONLY	        0x12
#define ENDPT_OUT_ONLY	        0x14
#define ENDPT_CONTROL	        0x16	/* enable for in, out and setup */
#define ENDPT_NON_CONTROL		0x1E	/* enable for in, and out */
#define PID_OUT		(0x01)
#define PID_ACK		(0x02)
#define PID_IN		(0x09)
#define PID_SETUP	(0x0D)
#define CLEAR_FEATURE	        0x01
#define GET_CONFIGURATION	0x08
#define GET_DESCRIPTOR	        0x06
#define GET_INTERFACE	        0x0A
#define GET_STATUS	        0x00
#define SET_ADDRESS	        0x05
#define SET_CONFIGURATION	0x09
#define SET_FEATURE	        0x03
#define SET_INTERFACE	        0x0B
#define VEND_SET_MEMORY	        0x80
#define HOSTTODEVICE            0x00
#define HOSTTOINTERFACE         0x01
#define HOSTTOENDPOINT          0x02
#define DEVICETOHOST            0x80
#define INTERFACETOHOST         0x81
#define ENDPOINTTOHOST          0x82

#define EP0OUT                  0
#define EP0IN                   1
#define EP1OUT                  2
#define EP1IN                   3
#define EP2OUT                  4
#define EP2IN                   5
#define EP3OUT                  6
#define EP3IN                   7
#define EP4OUT                  8
#define EP4IN                   9
#define EP5OUT                  10
#define EP5IN                   11
#define EP6OUT                  12
#define EP6IN                   13
#define EP7OUT                  14
#define EP7IN                   15
#define EP8OUT                  16
#define EP8IN                   17
#define EP9OUT                  18
#define EP9IN                   19
#define EP10OUT                 20
#define EP10IN                  21
#define EP11OUT                 22
#define EP11IN                  23
#define EP12OUT                 24
#define EP12IN                  25
#define EP13OUT                 26
#define EP13IN                  27
#define EP14OUT                 28
#define EP14IN                  29
#define EP15OUT                 30
#define EP15IN                  31
#define EP_IN	1
#define EP_OUT  0
#define EP2BF(x,y)			(x*2+y)

//Endpoint Type
#define EP_CONTROL	0
#define EP_BULK_IN	1
#define EP_BULK_OUT	2
#define EP_INT_IN	3
#define EP_INT_OUT	4
#define EP_ISO_IN	5
#define EP_ISO_OUT	6
// Descriptor Types
#define DEVICE                  1
#define CONFIGURATION           2
#define STRING                  3
#define INTERFACE               4
#define ENDPOINT                5
#define CS_INTERFACE            0x24
#define CS_ENDPOINT             0x25

//define some useful bit variables
volatile  bit  bDEV_ATT@UCON.USBEN;
volatile bit   bSUSPND@UCON.SUSPND;
volatile bit   bPKT_DIS@UCON.PKTDIS;
volatile  bit  bUIDLE@UIE.IDLEIE;
//ENABLE BITS
volatile  bit  bACTIVITY_E@UIE.ACTVIE;
volatile bit   bTOK_DONE_E@UIE.TRNIE; 
volatile bit  bPID_ERR_E@UEIE.PIDEE;
volatile bit  bCRC5_E@UEIE.CRC5EE;
volatile bit  bCRC16_E@UEIE.CRC16EE;
volatile bit  bDFN8_E@UEIE.DFN8EE;
volatile bit  bBTO_ERR_E@UEIE.BTOEE;
volatile bit  bBTS_ERR_E@UEIE.BTSEE;
volatile bit  bUSBRST_E@UIE.URSTIE;
volatile bit  bUSBIE@PIE2.USBIE;
//FLAG BITS
volatile bit   bSTALL@UIR.STALLIF;
volatile  bit  bUERR@UIR.UERRIF;
volatile bit  bPID_ERR@UEIR.PIDEF;
volatile bit  bCRC5@UEIR.CRC5EF; 
volatile  bit bCRC16@UEIR.CRC16EF;  
volatile bit  bDFN8@UEIR.DFN8EF;
volatile bit  bBTO_ERR@UEIR.BTOEF; 
volatile bit  bBTS_ERR@UEIR.BTSEF;
volatile bit bUSBIF@PIR2.USBIF;
volatile bit bUSBRST@UIR.URSTIF;
volatile bit bTMR0IF@INTCON.TMR0IF;
volatile bit   bACTIVITY@UIR.ACTVIF;
volatile bit   bTOK_DONE@UIR.TRNIF;

//BUFFER REGISTERS
char _usbbuf[152]@0x500;

#endif //#ifndef _USB_DEFS_

